# -*- coding: utf-8 -*-
"""
@Time: 2021/7/26 14:58
@Author: zzhang zzhang@cenboomh.com
@File: service2field.py
@desc:
"""
from collect.service_imp.common.filters.template_tool import TemplateTool
from collect.service_imp.request_handlers.request_handler import RequestHandler
from collect.utils.collect_utils import get_safe_data


class Service2Field(RequestHandler):
    def handler(self, params, config, template):
        service = get_safe_data(self.get_service_name(), config)
        if service:

            template_tool = TemplateTool(op_user=self.op_user)
            for key in service:
                value_template = service[key]
                value = template_tool.render(value_template, params)
                service[key] = value

            service_result = self.get_service_result(service, template)
            if not self.is_success(service_result):
                return service_result
            save_field = get_safe_data(self.get_save_field_name(), config)
            params[save_field] = self.get_data(service_result)

        return self.success(params)
